package org.etsi.its.tool.elvior;

import org.etsi.ttcn.tci.Type;
import org.etsi.ttcn.tci.Value;
import org.etsi.ttcn.tri.TriMessage;


/**
 * 
 * Note that "Enable Internal Codec" field shall be set to true
 *
 */
public class LibItsSremSsem_asn1 extends LibIts_asn1 {
    
    /**
     * Constructor
     */
    public LibItsSremSsem_asn1() {
        _logger.entering("LibItsSremSsem_asn1", "LibItsSremSsem_asn1");
        _encodingName = "SREM_SSEM_ETSI";
    }
    
    @Override
    public Value decode(final TriMessage message, final Type decodingHypothesis) {
        _logger.entering("LibItsSremSsem_asn1", "decode", decodingHypothesis.getName());
        
        if (decodingHypothesis.getName().endsWith("sremPacket")) {
            Type type = getTypeForName("SREM_PDU_Descriptions.MAPEM");
            return super.decode(message, type);
        } else if (decodingHypothesis.getName().endsWith("ssemPacket")) {
            Type type = getTypeForName("SSEM_PDU_Descriptions.SPATEM");
            return super.decode(message, type);
        }
        
        return super.decode(message, decodingHypothesis);
    }
    
} // End of class LibItsSremSsem_asn1 
